using System;
using System.Collections.Generic;
using System.Data.Linq;
using System.Linq;
using System.Linq.Expressions;
using System.Text;
using Platnosci.Core.Interface;
using Platnosci.Core.Linq;

namespace Platnosci.Core.Linq
{
    public sealed class RepositoryPotwierdzeniaEcard : IRepositoryPT
    {
        private readonly PlatnosciDataContext _dataContext = new PlatnosciDataContext();

        public int Count()
        {
            return _dataContext.GetTable<PotwierdzeniaEcard>().Count();
        }
        public int Count(Expression<Func<PotwierdzeniaEcard, bool>> expression)
        {
            return _dataContext.GetTable<PotwierdzeniaEcard>().Count(expression);
        }
        public PotwierdzeniaEcard FindOne(int id)
        {
            return FindOne(t => t.ORDERNUMBER == id);
        }
        public PotwierdzeniaEcard FindOne(Expression<Func<PotwierdzeniaEcard, bool>> expression)
        {
            return _dataContext.GetTable<PotwierdzeniaEcard>().Where(expression).SingleOrDefault();
        }

        public bool TryFindOne(Expression<Func<PotwierdzeniaEcard, bool>> expression, out PotwierdzeniaEcard entity)
        {
            entity = FindOne(expression);

            return (entity != null);
        }
        public bool Exists(Expression<Func<PotwierdzeniaEcard, bool>> expression)
        {
            var entity = FindOne(expression);

            return (entity != null);
        }
        public IList<PotwierdzeniaEcard> FindAll()
        {
            return _dataContext.GetTable<PotwierdzeniaEcard>().ToList();
        }
        public IList<PotwierdzeniaEcard> FindAll(Expression<Func<PotwierdzeniaEcard, bool>> expression)
        {
            return _dataContext.GetTable<PotwierdzeniaEcard>().Where(expression).ToList();
        }

        public void Insert(PotwierdzeniaEcard entity)
        {
            _dataContext.GetTable<PotwierdzeniaEcard>().InsertOnSubmit(entity);
            _dataContext.SubmitChanges();
        }
        public void Delete(PotwierdzeniaEcard entity)
        {
            if (entity != null)
            {
                _dataContext.GetTable<PotwierdzeniaEcard>().DeleteOnSubmit(entity);
                _dataContext.SubmitChanges();
            }
        }
        public void Update(PotwierdzeniaEcard entity)
        {
            _dataContext.SubmitChanges();
        }
        public IQueryable<PotwierdzeniaEcard> Find(int id)
        {
            return _dataContext.GetTable<PotwierdzeniaEcard>().Where(t => t.ORDERNUMBER == id);
        }
        public IQueryable<PotwierdzeniaEcard> Find(Expression<Func<PotwierdzeniaEcard, bool>> expression)
        {
            return _dataContext.GetTable<PotwierdzeniaEcard>().Where(expression);
        }
        public IQueryable<PotwierdzeniaEcard> Find()
        {
            return _dataContext.GetTable<PotwierdzeniaEcard>();
        }
    }
}


